| Face Engine SDK 5.2.0 A face detection, recognition and tracking engine.

- Main Page
- Modules
- Namespaces
- Classes
- Files

- Class List
- Class Index
- Class Hierarchy
- Class Members

All Classes Namespaces Files Functions Variables Typedefs Enumerations Enumerator Macros Groups Pages
Classes | Public Types | Public Member Functions | List of all members
fsdk::IAttributeEstimator Struct Referenceabstract

Face image attribute estimator interface. More...

`#include <IAttributeEstimator.h>`

Inheritance diagram for fsdk::IAttributeEstimator:

## Classes
struct | EstimationResult
| Unified Attribute Estimator output structure. More...

## Public Types
enum | EstimationRequest { estimateAge = 1 << 0, estimateGender = 1 << 1, estimateEthnicity = 1 << 2, estimateAll = 0xffff }
| EstimationRequest lists all possible estimation attributes that AttributeEstimator is currently able to estimate. More...

## Public Member Functions
virtual Result< FSDKError > | estimate (const Image &warp, const EstimationRequest request, EstimationResult &out) const noexcept=0
| Estimate unified attributes. More...
virtual ResultValue< FSDKError, EstimationResult > | estimate (Span< const Image > warps, const EstimationRequest request, Span< EstimationResult > results) const noexcept=0
| Estimate unified attributes of multiple frames in a single estimate function call. More...
virtual Result< FSDKError > | validate (Span< const Image > warps, const EstimationRequest request, Span< Result< FSDKError >> errors) const noexcept=0
| Validate input of multiple frames in a single function call. More...
Public Member Functions inherited from fsdk::IRefCounted
virtual int32_t | retain () noexcept=0
| Increase strong reference count. More...
virtual int32_t | release () noexcept=0
| Decrease strong reference count. More...
virtual int32_t | getRefCount () const noexcept=0
| Get actual strong reference count. More...
virtual int32_t | retainWeak () noexcept=0
| Increase weak reference count. More...
virtual int32_t | releaseWeak () noexcept=0
| Decrease weak reference count. More...
virtual int32_t | getWeakRefCount () const noexcept=0
| Get actual weak reference count. More...

## Detailed Description

Face image attribute estimator interface.

Note
  This estimator is designed to work with a person face image; you should pass a warped face detection image.

See Also
  IWarper for details.

Optional estimated attributes are:

- age;
- gender;
- ethnicity.
  See Also
    IAttributeEstimator::EstimationResult structure for details about how exactly the estimations are reported.

## Member Enumeration Documentation

enum fsdk::IAttributeEstimator::EstimationRequest

EstimationRequest lists all possible estimation attributes that AttributeEstimator is currently able to estimate.

Enumerator
estimateAge | Estimate age.
estimateGender | Estimate gender.
estimateEthnicity | Estimate Ethnicity.
estimateAll | Make full estimation (all attributes)

## Member Function Documentation

virtual Result<FSDKError> fsdk::IAttributeEstimator::estimate | ( | const Image & | warp,
|  | const EstimationRequest | request,
|  | EstimationResult & | out
| ) |  | const
| pure virtual noexcept

Estimate unified attributes.

Parameters

  [in] | warp | with warped face; format must be R8G8B8.
  [in] | request | EstimationRequest structure;

See Also
  EstimationRequests for more details.

Parameters

  [out] | out | output estimation;

See Also
  IAttributeEstimator::EstimationResult.

Returns
  Error code;

See Also
  FSDKError for details.

virtual ResultValue<FSDKError, EstimationResult> fsdk::IAttributeEstimator::estimate | ( | Span< const Image > | warps,
|  | const EstimationRequest | request,
|  | Span< EstimationResult > | results
| ) |  | const
| pure virtual noexcept

Estimate unified attributes of multiple frames in a single estimate function call.

Parameters

  [in] | warps | warps span; format must be R8G8B8.
  [in] | request | EstimationRequest structure.
  [out] | results | span of estimations.

Returns
  Error code and aggregative estimations result for all warps;

See Also
  FSDKError for details.
  IAttributeEstimator::EstimationResult, IAttributeEstimator::EstimationRequest and Span for more info.

Note
  all spans should be based on user owned continuous collections.
  all spans should be equal size

virtual Result<FSDKError> fsdk::IAttributeEstimator::validate | ( | Span< const Image > | warps,
|  | const EstimationRequest | request,
|  | Span< Result< FSDKError >> | errors
| ) |  | const
| pure virtual noexcept

Validate input of multiple frames in a single function call.

Parameters

  [in] | images | warps span
  [in] | request | EstimationRequest structure.
  [out] | errors | output span of errors for each image.

Returns
  Error code;

See Also
  FSDKError for details.

Note
  all spans should be based on user owned continuous collections.

The documentation for this struct was generated from the following file:

- include/fsdk/Estimators/IAttributeEstimator.h